Index: analyzer/pgmtexture.c
===================================================================
--- analyzer/pgmtexture.c.orig	2014-04-01 11:08:57.571334223 +0200
+++ analyzer/pgmtexture.c	2014-04-01 11:11:56.238523833 +0200
@@ -97,7 +97,7 @@
     float * v;
 
     assert(nh >= nl);
-
+    overflow_add(nh - nl, 1);
     MALLOCARRAY(v, (unsigned) (nh - nl + 1));
 
     if (v == NULL)
@@ -129,6 +129,7 @@
     assert(nrh >= nrl);
 
     /* allocate pointers to rows */
+    overflow_add(nrh - nrl, 1);
     MALLOCARRAY(m, (unsigned) (nrh - nrl + 1));
     if (m == NULL)
         pm_error("Unable to allocate memory for a matrix.");
@@ -136,7 +137,7 @@
     m -= ncl;
 
     assert (nch >= ncl);
-
+    overflow_add(nch - ncl, 1);
     /* allocate rows and set pointers to them */
     for (i = nrl; i <= nrh; ++i) {
         MALLOCARRAY(m[i], (unsigned) (nch - ncl + 1));
Index: converter/other/gemtopnm.c
===================================================================
--- converter/other/gemtopnm.c.orig	2014-04-01 11:09:00.724372879 +0200
+++ converter/other/gemtopnm.c	2014-04-01 11:11:56.238523833 +0200
@@ -106,6 +106,7 @@
 
 	pnm_writepnminit( stdout, cols, rows, MAXVAL, type, 0 );
 
+    overflow_add(cols, padright);
     { 
         /* allocate input row data structure */
         int plane;
Index: converter/other/jpegtopnm.c
===================================================================
--- converter/other/jpegtopnm.c.orig	2014-04-01 11:08:59.787361391 +0200
+++ converter/other/jpegtopnm.c	2014-04-01 11:11:56.239523845 +0200
@@ -861,6 +861,8 @@
     /* Calculate output image dimensions so we can allocate space */
     jpeg_calc_output_dimensions(cinfoP);
 
+    overflow2(cinfoP->output_width, cinfoP->output_components);
+
     /* Start decompressor */
     jpeg_start_decompress(cinfoP);
 
Index: converter/other/pbmtopgm.c
===================================================================
--- converter/other/pbmtopgm.c.orig	2014-04-01 11:09:00.724372879 +0200
+++ converter/other/pbmtopgm.c	2014-04-01 11:11:56.239523845 +0200
@@ -47,6 +47,7 @@
                  "than the image height (%u rows)", height, rows);
 
     outrow = pgm_allocrow(cols) ;
+    overflow2(width, height);
     maxval = MIN(PGM_OVERALLMAXVAL, width*height);
     pgm_writepgminit(stdout, cols, rows, maxval, 0) ;
 
Index: converter/other/pnmtoddif.c
===================================================================
--- converter/other/pnmtoddif.c.orig	2014-04-01 11:09:00.817374019 +0200
+++ converter/other/pnmtoddif.c	2014-04-01 11:11:56.239523845 +0200
@@ -632,6 +632,7 @@
     switch (PNM_FORMAT_TYPE(format)) {
     case PBM_TYPE:
         ip.bits_per_pixel = 1;
+        overflow_add(cols, 7);
         ip.bytes_per_line = (cols + 7) / 8;
         ip.spectral = 2;
         ip.components = 1;
@@ -647,6 +648,7 @@
         ip.polarity = 2;
         break;
     case PPM_TYPE:
+        overflow2(cols, 3);
         ip.bytes_per_line = 3 * cols;
         ip.bits_per_pixel = 24;
         ip.spectral = 5;
Index: converter/other/pnmtojpeg.c
===================================================================
--- converter/other/pnmtojpeg.c.orig	2014-04-01 11:08:59.297355384 +0200
+++ converter/other/pnmtojpeg.c	2014-04-01 11:11:56.239523845 +0200
@@ -605,7 +605,11 @@
            want JPOOL_PERMANENT.  
         */
         const unsigned int scan_info_size = nscans * sizeof(jpeg_scan_info);
-        jpeg_scan_info * const scan_info = 
+        const jpeg_scan_info * scan_info;
+      
+        overflow2(nscans, sizeof(jpeg_scan_info));
+      
+        scan_info =
             (jpeg_scan_info *)
             (*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_IMAGE,
                                         scan_info_size);
@@ -937,6 +941,8 @@
   const long half_maxval = maxval / 2;
   long val;
 
+  overflow_add(maxval, 1);
+  overflow2(maxval+1, sizeof(JSAMPLE));
   *rescale_p = (JSAMPLE *)
     (cinfo.mem->alloc_small) ((j_common_ptr) &cinfo, JPOOL_IMAGE,
                               (size_t) (((long) maxval + 1L) * 
@@ -1015,6 +1021,7 @@
     */
 
   /* Allocate the libpnm output and compressor input buffers */
+  overflow2(cinfo_p->image_width, cinfo_p->input_components);
   buffer = (*cinfo_p->mem->alloc_sarray)
     ((j_common_ptr) cinfo_p, JPOOL_IMAGE,
      (unsigned int) cinfo_p->image_width * cinfo_p->input_components, 
Index: converter/other/pnmtops.c
===================================================================
--- converter/other/pnmtops.c.orig	2014-04-01 11:08:59.786361379 +0200
+++ converter/other/pnmtops.c	2014-04-01 11:11:56.240523858 +0200
@@ -292,17 +292,21 @@
     validateCompDimension(width, 72, "-width value");
     validateCompDimension(height, 72, "-height value");
     
+    overflow2(width, 72);
     cmdlineP->width  = width * 72;
+    overflow2(height, 72);
     cmdlineP->height = height * 72;
 
     if (imagewidthSpec) {
         validateCompDimension(imagewidth, 72, "-imagewidth value");
+        overflow2(imagewidth, 72);
         cmdlineP->imagewidth = imagewidth * 72;
     }
     else
         cmdlineP->imagewidth = 0;
     if (imageheightSpec) {
-        validateCompDimension(imagewidth, 72, "-imageheight value");
+        validateCompDimension(imageheight, 72, "-imageheight value");
+        overflow2(imageheight, 72);
         cmdlineP->imageheight = imageheight * 72;
     }
     else
Index: converter/other/pnmtorle.c
===================================================================
--- converter/other/pnmtorle.c.orig	2014-04-01 11:09:00.719372817 +0200
+++ converter/other/pnmtorle.c	2014-04-01 11:11:56.240523858 +0200
@@ -19,6 +19,8 @@
  * If you modify this software, you should include a notice giving the
  * name of the person performing the modification, the date of modification,
  * and the reason for such modification.
+ *
+ *  2002-12-19: Fix maths wrapping bugs. Alan Cox <alan@redhat.com>
  */
 /*
  * pnmtorle - A program which will convert pbmplus (ppm or pgm) images
Index: converter/other/pnmtosgi.c
===================================================================
--- converter/other/pnmtosgi.c.orig	2014-04-01 11:09:00.727372916 +0200
+++ converter/other/pnmtosgi.c	2014-04-01 11:11:56.240523858 +0200
@@ -254,6 +254,7 @@
 #endif
 
     if( storage != STORAGE_VERBATIM ) {
+        overflow2(channels, rows);
         MALLOCARRAY_NOFAIL(table, channels * rows);
         MALLOCARRAY_NOFAIL(rletemp, WORSTCOMPR(cols));
     }
@@ -306,6 +307,8 @@
             break;
         case STORAGE_RLE:
             tabrow = chan_no * rows + row;
+            overflow2(chan_no, rows);
+            overflow_add(chan_no* rows, row);
             len = rle_compress(temp, cols);    /* writes result into rletemp */
             channel[chan_no][row].length = len;
             MALLOCARRAY(p, len);
Index: converter/other/rletopnm.c
===================================================================
--- converter/other/rletopnm.c.orig	2014-04-01 11:09:00.718372805 +0200
+++ converter/other/rletopnm.c	2014-04-01 11:11:56.241523870 +0200
@@ -19,6 +19,8 @@
  * If you modify this software, you should include a notice giving the
  * name of the person performing the modification, the date of modification,
  * and the reason for such modification.
+ *
+ *  2002-12-19: Fix maths wrapping bugs. Alan Cox <alan@redhat.com>
  */
 /*
  * rletopnm - A conversion program to convert from Utah's "rle" image format
Index: converter/other/sgitopnm.c
===================================================================
--- converter/other/sgitopnm.c.orig	2014-04-01 11:09:00.727372916 +0200
+++ converter/other/sgitopnm.c	2014-04-01 11:11:56.241523870 +0200
@@ -359,10 +359,14 @@
         MALLOCARRAY_NOFAIL(image, head->ysize);
     } else {
         maxchannel = MIN(3, head->zsize);
+        overflow2(head->ysize, maxchannel);
         MALLOCARRAY_NOFAIL(image, head->ysize * maxchannel);
     }
-    if (table) 
+    if (table) {
+        overflow2(head->xsize, 2);
+        overflow_add(head->xsize*2, 2);
         MALLOCARRAY_NOFAIL(temp, WORSTCOMPR(head->xsize));
+    }
 
     for (channel = 0; channel < maxchannel; ++channel) {
         unsigned int row;
Index: converter/other/sirtopnm.c
===================================================================
--- converter/other/sirtopnm.c.orig	2014-04-01 11:09:00.721372842 +0200
+++ converter/other/sirtopnm.c	2014-04-01 11:11:56.241523870 +0200
@@ -69,6 +69,7 @@
 	    }
 	    break;
 	case PPM_TYPE:
+	    overflow3(cols, rows, 3);
 	    picsize = cols * rows * 3;
 	    planesize = cols * rows;
             if ( !( sirarray = (unsigned char*) malloc( picsize ) ) ) 
Index: converter/other/tifftopnm.c
===================================================================
--- converter/other/tifftopnm.c.orig	2014-04-01 11:09:00.728372928 +0200
+++ converter/other/tifftopnm.c	2014-04-01 11:11:56.242523882 +0200
@@ -1279,7 +1279,9 @@
     if (scanbuf == NULL)
         pm_error("can't allocate memory for scanline buffer");
 
-    MALLOCARRAY(samplebuf, cols * spp);
+    /* samplebuf is unsigned int * !!! */
+    samplebuf = (unsigned int *) malloc3(cols , sizeof(unsigned int) , spp);
+
     if (samplebuf == NULL)
         pm_error("can't allocate memory for row buffer");
 
Index: converter/other/xwdtopnm.c
===================================================================
--- converter/other/xwdtopnm.c.orig	2014-04-01 11:08:59.937363230 +0200
+++ converter/other/xwdtopnm.c	2014-04-01 11:11:56.242523882 +0200
@@ -209,6 +209,10 @@
         *colorsP = pnm_allocrow(2);
         PNM_ASSIGN1((*colorsP)[0], 0);
         PNM_ASSIGN1((*colorsP)[1], *maxvalP);
+        overflow_add(h10P->pixmap_width, 15);
+        if(h10P->pixmap_width < 0)
+            pm_error("assert: negative width");
+        overflow2((((h10P->pixmap_width + 15) / 16) * 16 - h10P->pixmap_width), 8);
         *padrightP =
             (((h10P->pixmap_width + 15) / 16) * 16 - h10P->pixmap_width) * 8;
         *bits_per_itemP = 16;
@@ -634,6 +638,7 @@
 
     *colsP = h11FixedP->pixmap_width;
     *rowsP = h11FixedP->pixmap_height;
+    overflow2(h11FixedP->bytes_per_line, 8);
     *padrightP =
         h11FixedP->bytes_per_line * 8 -
         h11FixedP->pixmap_width * h11FixedP->bits_per_pixel;
Index: converter/pbm/mdatopbm.c
===================================================================
--- converter/pbm/mdatopbm.c.orig	2014-04-01 11:09:01.991388412 +0200
+++ converter/pbm/mdatopbm.c	2014-04-01 11:11:56.242523882 +0200
@@ -245,10 +245,13 @@
         pm_readlittleshort(infile, &yy); nInCols = yy;
     }
     
+    overflow2(nOutCols, 8);
     nOutCols = 8 * nInCols;
     nOutRows = nInRows;
-    if (bScale) 
+    if (bScale) {
+        overflow2(nOutRows, 2);
         nOutRows *= 2;
+    }
 
     data = pbm_allocarray(nOutCols, nOutRows);
     
Index: converter/pbm/mgrtopbm.c
===================================================================
--- converter/pbm/mgrtopbm.c.orig	2014-04-01 11:09:02.082389528 +0200
+++ converter/pbm/mgrtopbm.c	2014-04-01 11:11:56.242523882 +0200
@@ -65,6 +65,8 @@
     if (head.h_high < ' ' || head.l_high < ' ')
         pm_error("Invalid width field in MGR header");
     
+    overflow_add(*colsP, pad);
+
     *colsP = (((int)head.h_wide - ' ') << 6) + ((int)head.l_wide - ' ');
     *rowsP = (((int)head.h_high - ' ') << 6) + ((int) head.l_high - ' ');
     *padrightP = ( ( *colsP + pad - 1 ) / pad ) * pad - *colsP;
Index: converter/pbm/pbmtogem.c
===================================================================
--- converter/pbm/pbmtogem.c.orig	2014-04-01 11:09:01.993388437 +0200
+++ converter/pbm/pbmtogem.c	2014-04-01 11:11:56.243523894 +0200
@@ -79,6 +79,7 @@
   bitsperitem = 0;
   bitshift = 7;
   outcol = 0;
+  overflow_add(cols, 7);
   outmax = (cols + 7) / 8;
   outrow = (unsigned char *) pm_allocrow (outmax, sizeof (unsigned char));
   lastrow = (unsigned char *) pm_allocrow (outmax, sizeof (unsigned char));
Index: converter/pbm/pbmtogo.c
===================================================================
--- converter/pbm/pbmtogo.c.orig	2014-04-01 11:09:02.078389479 +0200
+++ converter/pbm/pbmtogo.c	2014-04-01 11:11:56.243523894 +0200
@@ -158,6 +158,7 @@
     bitrow = pbm_allocrow(cols);
 
     /* Round cols up to the nearest multiple of 8. */
+    overflow_add(cols, 7);
     rucols = ( cols + 7 ) / 8;
     bytesperrow = rucols;       /* GraphOn uses bytes */
     rucols = rucols * 8;
Index: converter/pbm/pbmtolj.c
===================================================================
--- converter/pbm/pbmtolj.c.orig	2014-04-01 11:09:01.992388424 +0200
+++ converter/pbm/pbmtolj.c	2014-04-01 11:11:56.243523894 +0200
@@ -120,7 +120,11 @@
 static void
 allocateBuffers(unsigned int const cols) {
 
+    overflow_add(cols, 8);
     rowBufferSize = (cols + 7) / 8;
+    overflow_add(rowBufferSize, 128);
+    overflow_add(rowBufferSize, rowBufferSize+128);
+    overflow_add(rowBufferSize+10, rowBufferSize/8);
     packBufferSize = rowBufferSize + (rowBufferSize + 127) / 128 + 1;
     deltaBufferSize = rowBufferSize + rowBufferSize / 8 + 10;
 
Index: converter/pbm/pbmtomacp.c
===================================================================
--- converter/pbm/pbmtomacp.c.orig	2014-04-01 11:09:01.997388486 +0200
+++ converter/pbm/pbmtomacp.c	2014-04-01 11:11:56.243523894 +0200
@@ -101,6 +101,7 @@
   if( !lflg )
     left = 0;
 
+  overflow_add(left, MAX_COLS - 1);
   if( rflg )
   { if( right - left >= MAX_COLS )
       right = left + MAX_COLS - 1;
@@ -111,6 +112,8 @@
   if( !tflg )
     top = 0;
 
+  overflow_add(top, MAX_LINES - 1);
+
   if( bflg )
   { if( bottom - top >= MAX_LINES )
       bottom = top + MAX_LINES - 1;
Index: converter/pbm/pbmtomda.c
===================================================================
--- converter/pbm/pbmtomda.c.orig	2014-04-01 11:09:02.077389466 +0200
+++ converter/pbm/pbmtomda.c	2014-04-01 11:11:56.243523894 +0200
@@ -179,6 +179,7 @@
     
     nOutRowsUnrounded = bScale ? nInRows/2 : nInRows;
 
+    overflow_add(nOutRowsUnrounded, 3);
     nOutRows = ((nOutRowsUnrounded + 3) / 4) * 4;
         /* MDA wants rows a multiple of 4 */   
     nOutCols = nInCols / 8;
Index: converter/pbm/pbmtoppa/pbm.c
===================================================================
--- converter/pbm/pbmtoppa/pbm.c.orig	2014-04-01 11:09:02.000388522 +0200
+++ converter/pbm/pbmtoppa/pbm.c	2014-04-01 11:11:56.244523907 +0200
@@ -105,6 +105,7 @@
     return 0;
 
   case P4:
+    overflow_add(pbm->width, 7);
     tmp=(pbm->width+7)/8;
     tmp2=fread(data,1,tmp,pbm->fptr);
     if(tmp2 == tmp)
@@ -129,7 +130,8 @@
     return;
 
   pbm->unread = 1;
-  pbm->revdata = malloc ((pbm->width+7)/8);
+  overflow_add(pbm->width, 7);
+  pbm->revdata = malloc((pbm->width+7)/8);
   memcpy (pbm->revdata, data, (pbm->width+7)/8);
   pbm->current_line--;
 }
Index: converter/pbm/pbmtoppa/pbmtoppa.c
===================================================================
--- converter/pbm/pbmtoppa/pbmtoppa.c.orig	2014-04-01 11:09:02.001388535 +0200
+++ converter/pbm/pbmtoppa/pbmtoppa.c	2014-04-01 11:11:56.244523907 +0200
@@ -441,6 +441,7 @@
             pm_error("main(): unrecognized parameter '%s'", argv[argn]);
     }
 
+    overflow_add(Width, 7);
     Pwidth=(Width+7)/8;
     printer.fptr=out;
 
Index: converter/pbm/pbmtoxbm.c
===================================================================
--- converter/pbm/pbmtoxbm.c.orig	2014-04-01 11:09:02.082389528 +0200
+++ converter/pbm/pbmtoxbm.c	2014-04-01 11:11:56.244523907 +0200
@@ -335,6 +335,8 @@
 
     unsigned char * bitrow;
     unsigned int row;
+    
+    overflow_add(cols, padright);
 
     putinit(xbmVersion);
 
Index: converter/pbm/pbmtoybm.c
===================================================================
--- converter/pbm/pbmtoybm.c.orig	2014-04-01 11:09:02.082389528 +0200
+++ converter/pbm/pbmtoybm.c	2014-04-01 11:11:56.244523907 +0200
@@ -113,6 +113,7 @@
     bitrow = pbm_allocrow(cols);
     
     /* Compute padding to round cols up to the nearest multiple of 16. */
+    overflow_add(cols, 16);
     padright = ((cols + 15) / 16) * 16 - cols;
 
     putinit(cols, rows);
Index: converter/pbm/pbmtozinc.c
===================================================================
--- converter/pbm/pbmtozinc.c.orig	2014-04-01 11:09:02.077389466 +0200
+++ converter/pbm/pbmtozinc.c	2014-04-01 11:11:56.244523907 +0200
@@ -65,6 +65,7 @@
     bitrow = pbm_allocrow( cols );
 
     /* Compute padding to round cols up to the nearest multiple of 16. */
+    overflow_add(cols, 16);
     padright = ( ( cols + 15 ) / 16 ) * 16 - cols;
 
     printf( "USHORT %s[] = {\n",name);
Index: converter/pbm/pbmto10x.c
===================================================================
--- converter/pbm/pbmto10x.c.orig	2014-04-01 11:09:01.993388437 +0200
+++ converter/pbm/pbmto10x.c	2014-04-01 11:11:56.245523919 +0200
@@ -162,7 +162,7 @@
         res_60x72();
 
     pm_close(ifp);
-    exit(0);
+    return 0;
 }
 
 
Index: converter/pbm/pbmto4425.c
===================================================================
--- converter/pbm/pbmto4425.c.orig	2014-04-01 11:09:01.990388400 +0200
+++ converter/pbm/pbmto4425.c	2014-04-01 11:11:56.245523919 +0200
@@ -2,6 +2,7 @@
 
 #include "nstring.h"
 #include "pbm.h"
+#include <string.h>
 
 static char bit_table[2][3] = {
 {1, 4, 0x10},
@@ -160,7 +161,7 @@
     xres = vmap_width * 2;
     yres = vmap_height * 3;
 
-    vmap = malloc(vmap_width * vmap_height * sizeof(char));
+    vmap = malloc3(vmap_width, vmap_height, sizeof(char));
     if(vmap == NULL)
 	{
         pm_error( "Cannot allocate memory" );
Index: converter/pbm/pktopbm.c
===================================================================
--- converter/pbm/pktopbm.c.orig	2014-04-01 11:09:01.994388449 +0200
+++ converter/pbm/pktopbm.c	2014-04-01 11:11:56.245523919 +0200
@@ -277,6 +277,7 @@
         if (flagbyte == 7) {            /* long form preamble */
             integer packetlength = get32() ;    /* character packet length */
             car = get32() ;         /* character number */
+            overflow_add(packetlength, pktopbm_pkloc);
             endofpacket = packetlength + pktopbm_pkloc;
                 /* calculate end of packet */
             if ((car >= MAXPKCHAR) || !filename[car]) {
Index: converter/pbm/thinkjettopbm.l
===================================================================
--- converter/pbm/thinkjettopbm.l.orig	2014-04-01 11:09:02.083389540 +0200
+++ converter/pbm/thinkjettopbm.l	2014-04-01 11:11:56.245523919 +0200
@@ -114,7 +114,9 @@
 <RASTERMODE>\033\*b{DIG}+W  {
                             int l;
                             if (rowCount >= rowCapacity) {
+				overflow_add(rowCapacity, 100);
                                 rowCapacity += 100;
+				overflow2(rowCapacity, sizeof *rows);
                                 rows = realloc (rows, rowCapacity * sizeof *rows);
                                 if (rows == NULL)
                                     pm_error ("Out of memory.");
@@ -226,6 +228,8 @@
     /*
      * Quite simple since ThinkJet bit arrangement matches PBM
      */
+
+    overflow2(maxRowLength, 8);
     pbm_writepbminit(stdout, maxRowLength*8, rowCount, 0);
 
     packed_bitrow = malloc(maxRowLength);
Index: converter/pbm/ybmtopbm.c
===================================================================
--- converter/pbm/ybmtopbm.c.orig	2014-04-01 11:09:01.998388498 +0200
+++ converter/pbm/ybmtopbm.c	2014-04-01 11:11:56.245523919 +0200
@@ -49,6 +49,7 @@
         pm_error("EOF / read error");
 
     *depthP = 1;
+    overflow_add(*colsP, 15);
     *padrightP = ((*colsP + 15) / 16) * 16 - *colsP;
 }
 
Index: converter/pgm/lispmtopgm.c
===================================================================
--- converter/pgm/lispmtopgm.c.orig	2014-04-01 11:09:00.882374816 +0200
+++ converter/pgm/lispmtopgm.c	2014-04-01 11:11:56.246523931 +0200
@@ -58,6 +58,7 @@
         pm_error( "depth (%d bits) is too large", depth);
 
     pgm_writepgminit( stdout, cols, rows, (gray) maxval, 0 );
+    overflow_add(cols, 7);
     grayrow = pgm_allocrow( ( cols + 7 ) / 8 * 8 );
 
     for ( row = 0; row < rows; ++row )
@@ -102,7 +103,9 @@
     
     if ( *depthP == 0 )
 	*depthP = 1;	/* very old file */
-    
+
+    overflow_add((int)colsP, 31);
+        
     *padrightP = ( ( *colsP + 31 ) / 32 ) * 32 - *colsP;
     
     if ( *colsP != (cols_32 - *padrightP) ) {
Index: converter/pgm/psidtopgm.c
===================================================================
--- converter/pgm/psidtopgm.c.orig	2014-04-01 11:09:00.881374803 +0200
+++ converter/pgm/psidtopgm.c	2014-04-01 11:11:56.246523931 +0200
@@ -78,6 +78,7 @@
         pm_error("bits/sample (%d) is too large.", bitspersample);
 
     pgm_writepgminit(stdout, cols, rows, maxval, 0);
+    overflow_add(cols, 7);
     grayrow = pgm_allocrow((cols + 7) / 8 * 8);
     for (row = 0; row < rows; ++row) {
         unsigned int col;
Index: converter/ppm/ilbmtoppm.c
===================================================================
--- converter/ppm/ilbmtoppm.c.orig	2014-04-01 11:09:01.846386634 +0200
+++ converter/ppm/ilbmtoppm.c	2014-04-01 11:11:56.246523931 +0200
@@ -592,6 +592,7 @@
     rawtype *chp;
 
     cols = bmhdP->w;
+    overflow_add(cols, 15);
     bytes = RowBytes(cols);
     for( plane = 0; plane < nPlanes; plane++ ) {
         int mask;
@@ -679,6 +680,23 @@
  Multipalette handling
  ****************************************************************************/
 
+static void *
+xmalloc2(x, y)
+    int x;
+    int y;
+{
+    void *mem;
+
+    overflow2(x,y);
+    if( x * y == 0 )
+        return NULL;
+
+    mem = malloc2(x,y);
+    if( mem == NULL )
+        pm_error("out of memory allocating %d bytes", x * y);
+    return mem;
+}
+
 
 static void
 multi_adjust(cmap, row, palchange)
@@ -1341,6 +1359,9 @@
     if( redmaxval != maxval || greenmaxval != maxval || bluemaxval != maxval )
         pm_message("scaling colors to %d bits", pm_maxvaltobits(maxval));
     
+    overflow_add(redmaxval, 1);
+    overflow_add(greenmaxval, 1);
+    overflow_add(bluemaxval, 1);
     MALLOCARRAY_NOFAIL(redtable,   redmaxval   +1);
     MALLOCARRAY_NOFAIL(greentable, greenmaxval +1);
     MALLOCARRAY_NOFAIL(bluetable,  bluemaxval  +1);
@@ -1763,7 +1784,9 @@
             ChangeCount32 = *data++;
             datasize -= 2;
 
+            overflow_add(ChangeCount16, ChangeCount32);
             changes = ChangeCount16 + ChangeCount32;
+            overflow_add(changes, 1);
             for( i = 0; i < changes; i++ ) {
                 if( totalchanges >= PCHG->TotalChanges ) goto fail;
                 if( datasize < 2 ) goto fail;
@@ -2028,6 +2051,9 @@
             cmap->mp_change[i] = NULL;
         if( PCHG.StartLine < 0 ) {
             int nch;
+            if(PCHG.MaxReg < PCHG.MinReg)
+                pm_error("assert: MinReg > MaxReg");
+            overflow_add(PCHG.MaxReg-PCHG.MinReg, 2);
             nch = PCHG.MaxReg - PCHG.MinReg +1;
             MALLOCARRAY_NOFAIL(cmap->mp_init, nch + 1);
             for( i = 0; i < nch; i++ )
@@ -2104,6 +2130,7 @@
     if( typeid == ID_ILBM ) {
         int isdeep;
 
+        overflow_add(bmhdP->w, 15);
         MALLOCARRAY_NOFAIL(ilbmrow, RowBytes(bmhdP->w));
         *viewportmodesP |= fakeviewport;      /* -isham/-isehb */
 
Index: converter/ppm/imgtoppm.c
===================================================================
--- converter/ppm/imgtoppm.c.orig	2014-04-01 11:09:01.675384538 +0200
+++ converter/ppm/imgtoppm.c	2014-04-01 11:11:56.247523943 +0200
@@ -84,6 +84,7 @@
             len = atoi((char*) buf );
             if ( fread( buf, len, 1, ifp ) != 1 )
                 pm_error( "bad colormap buf" );
+            overflow2(cmaplen, 3);
             if ( cmaplen * 3 != len )
             {
                 pm_message(
@@ -105,6 +106,7 @@
                 pm_error( "bad pixel data header" );
             buf[8] = '\0';
             len = atoi((char*) buf );
+            overflow2(cols, rows);
             if ( len != cols * rows )
                 pm_message(
                     "pixel data length (%d) does not match image size (%d)",
Index: converter/ppm/Makefile
===================================================================
--- converter/ppm/Makefile.orig	2014-04-01 11:09:01.675384538 +0200
+++ converter/ppm/Makefile	2014-04-01 11:11:56.247523943 +0200
@@ -11,7 +11,7 @@
 
 PORTBINARIES =	411toppm eyuvtoppm gouldtoppm ilbmtoppm imgtoppm \
 		leaftoppm mtvtoppm neotoppm \
-		pcxtoppm pc1toppm pi1toppm picttoppm pjtoppm \
+		pcxtoppm pc1toppm pi1toppm pjtoppm \
 		ppmtoacad ppmtoapplevol ppmtoarbtxt ppmtoascii \
 		ppmtobmp ppmtoeyuv ppmtogif ppmtoicr ppmtoilbm \
 		ppmtoleaf ppmtolj ppmtomitsu ppmtoneo \
Index: converter/ppm/pcxtoppm.c
===================================================================
--- converter/ppm/pcxtoppm.c.orig	2014-04-01 11:09:01.847386646 +0200
+++ converter/ppm/pcxtoppm.c	2014-04-01 11:11:56.247523943 +0200
@@ -409,6 +409,7 @@
     /*
      * clear the pixel buffer
      */
+    overflow2(bytesperline, 8);
     npixels = (bytesperline * 8) / bitsperpixel;
     p    = pixels;
     while (--npixels >= 0)
@@ -470,6 +471,7 @@
     }
 
     /*  BytesPerLine should be >= BitsPerPixel * cols / 8  */
+    overflow2(BytesPerLine, 8);
     rawcols = BytesPerLine * 8 / BitsPerPixel;
     if (headerCols > rawcols) {
         pm_message("warning - BytesPerLine = %d, "
Index: converter/ppm/picttoppm.c
===================================================================
--- converter/ppm/picttoppm.c.orig	2014-04-01 11:09:01.848386659 +0200
+++ converter/ppm/picttoppm.c	2014-04-01 11:11:56.248523955 +0200
@@ -1,3 +1,5 @@
+#error "Unfixable. Don't ship me"
+
 /*
  * picttoppm.c -- convert a MacIntosh PICT file to PPM format.
  *
Index: converter/ppm/pjtoppm.c
===================================================================
--- converter/ppm/pjtoppm.c.orig	2014-04-01 11:09:01.839386548 +0200
+++ converter/ppm/pjtoppm.c	2014-04-01 11:11:56.248523955 +0200
@@ -127,19 +127,21 @@
                 case 'V':   /* send plane */
                 case 'W':   /* send last plane */
                     if (rows == -1 || r >= rows || image == NULL) {
-                        if (rows == -1 || r >= rows)
+                        if (rows == -1 || r >= rows) {
+                            overflow_add(rows, 100);
                             rows += 100;
+                        }
                         if (image == NULL) {
-                            MALLOCARRAY(image, rows * planes);
-                            MALLOCARRAY(imlen, rows * planes);
+                            image = (unsigned char **)
+                                malloc3(rows , planes , sizeof(unsigned char *));
+                            imlen = (int *) malloc3(rows , planes,  sizeof(int));
                         }
                         else {
+                            overflow2(rows,planes);
                             image = (unsigned char **) 
-                                realloc(image, 
-                                        rows * planes * 
+                                realloc2(image, rows * planes,
                                         sizeof(unsigned char *));
-                            imlen = (int *) 
-                                realloc(imlen, rows * planes * sizeof(int));
+                            imlen = (int *) realloc2(imlen, rows * planes, sizeof(int));
                         }
                     }
                     if (image == NULL || imlen == NULL)
@@ -212,8 +214,10 @@
                 for (i = 0, c = 0; c < imlen[p + r * planes]; c += 2)
                     for (cmd = image[p + r * planes][c],
                              val = image[p + r * planes][c+1]; 
-                         cmd >= 0 && i < newcols; cmd--, i++) 
+                         cmd >= 0 && i < newcols; cmd--, i++) {
                         buf[i] = val;
+                        overflow_add(i, 1);
+                    }
                 cols = cols > i ? cols : i;
                 free(image[p + r * planes]);
                 /* 
@@ -224,6 +228,7 @@
                 image[p + r * planes] = (unsigned char *) realloc(buf, i);
             }
         }
+        overflow2(cols, 8);
         cols *= 8;
     }
             
Index: converter/ppm/ppmtoeyuv.c
===================================================================
--- converter/ppm/ppmtoeyuv.c.orig	2014-04-01 11:09:00.999376250 +0200
+++ converter/ppm/ppmtoeyuv.c	2014-04-01 11:11:56.248523955 +0200
@@ -114,6 +114,7 @@
 
     int index;
 
+    overflow_add(maxval, 1);
     MALLOCARRAY_NOFAIL(mult299   , maxval+1);
     MALLOCARRAY_NOFAIL(mult587   , maxval+1);
     MALLOCARRAY_NOFAIL(mult114   , maxval+1);
Index: converter/ppm/ppmtoicr.c
===================================================================
--- converter/ppm/ppmtoicr.c.orig	2014-04-01 11:09:01.675384538 +0200
+++ converter/ppm/ppmtoicr.c	2014-04-01 11:11:56.248523955 +0200
@@ -169,7 +169,7 @@
 
 	if (rleflag) {	
 		pm_message("sending run-length encoded picture data ..." );
-		testimage = (char*) malloc(rows*cols);
+		testimage = (char*) malloc2(rows, cols);
 		p = testimage;
 		for (i=0; i<rows; i++)
 			for (j=0; j<cols; j++) 
Index: converter/ppm/ppmtoilbm.c
===================================================================
--- converter/ppm/ppmtoilbm.c.orig	2014-04-01 11:09:00.997376226 +0200
+++ converter/ppm/ppmtoilbm.c	2014-04-01 11:11:56.249523968 +0200
@@ -185,6 +185,7 @@
     unsigned int i;
     int * table;
 
+    overflow_add(oldmaxval, 1);
     MALLOCARRAY_NOFAIL(table, oldmaxval + 1);
     for (i = 0; i <= oldmaxval; ++i)
         table[i] = ROUNDDIV(i * newmaxval, oldmaxval);
@@ -1675,6 +1676,7 @@
 
     maskmethod = 0;     /* no masking - RGB8 uses genlock bits */
     compmethod = 4;     /* RGB8 files are always compressed */
+    overflow2(cols, 4);
     MALLOCARRAY_NOFAIL(compr_row, cols * 4);
 
     if( maxval != 255 ) {
@@ -1766,6 +1768,7 @@
 
     maskmethod = 0;     /* no masking - RGBN uses genlock bits */
     compmethod = 4;     /* RGBN files are always compressed */
+    overflow2(cols, 2);
     MALLOCARRAY_NOFAIL(compr_row, cols * 2);
 
     if( maxval != 15 ) {
@@ -2328,8 +2331,11 @@
         MALLOCARRAY_NOFAIL(coded_rowbuf, RowBytes(cols));
         for (i = 0; i < RowBytes(cols); ++i)
             coded_rowbuf[i] = 0;
-        if (DO_COMPRESS)
+        if (DO_COMPRESS) {
+            overflow2(cols,2);
+            overflow_add(cols*2,2);
             MALLOCARRAY_NOFAIL(compr_rowbuf, WORSTCOMPR(RowBytes(cols)));
+	}
     }
     
     switch (mode) {
Index: converter/ppm/ppmtolj.c
===================================================================
--- converter/ppm/ppmtolj.c.orig	2014-04-01 11:09:01.001376275 +0200
+++ converter/ppm/ppmtolj.c	2014-04-01 11:11:56.249523968 +0200
@@ -181,7 +181,8 @@
 
     ppm_readppminit( ifp, &cols, &rows, &maxval, &format );
     pixelrow = ppm_allocrow( cols );
-
+    
+    overflow2(cols, 6);
     obuf = (unsigned char *) pm_allocrow(cols * 3, sizeof(unsigned char));
     cbuf = (unsigned char *) pm_allocrow(cols * 6, sizeof(unsigned char));
     if (mode == C_TRANS_MODE_DELTA)
Index: converter/ppm/ppmtomitsu.c
===================================================================
--- converter/ppm/ppmtomitsu.c.orig	2014-04-01 11:09:01.839386548 +0200
+++ converter/ppm/ppmtomitsu.c	2014-04-01 11:11:56.249523968 +0200
@@ -685,6 +685,8 @@
         medias = MSize_User;
 
     if (dpi300) {
+        overflow2(medias.maxcols, 2);
+        overflow2(medias.maxrows, 2);
         medias.maxcols *= 2;
         medias.maxrows *= 2;
     }
Index: converter/ppm/ppmtopcx.c
===================================================================
--- converter/ppm/ppmtopcx.c.orig	2014-04-01 11:09:01.676384550 +0200
+++ converter/ppm/ppmtopcx.c	2014-04-01 11:11:56.250523980 +0200
@@ -419,6 +419,8 @@
             else                   Planes = 1;
         }
     }
+    overflow2(BitsPerPixel, cols);
+    overflow_add(BitsPerPixel * cols, 7);
     BytesPerLine = ((cols * BitsPerPixel) + 7) / 8;
     MALLOCARRAY_NOFAIL(indexRow, cols);
     MALLOCARRAY_NOFAIL(planesrow, BytesPerLine);
Index: converter/ppm/ppmtopict.c
===================================================================
--- converter/ppm/ppmtopict.c.orig	2014-04-01 11:09:01.001376275 +0200
+++ converter/ppm/ppmtopict.c	2014-04-01 11:11:56.250523980 +0200
@@ -441,6 +441,8 @@
     putShort(stdout, 0);            /* mode */
 
     /* Finally, write out the data. */
+    overflow_add(cols/MAX_COUNT, 1);
+    overflow_add(cols, cols/MAX_COUNT+1);
     packed = malloc((unsigned)(cols+cols/MAX_COUNT+1));
     for (row = 0, oc = 0; row < rows; row++)
         oc += putRow(stdout, row, cols, pixels[row], packed);
Index: converter/ppm/ppmtopj.c
===================================================================
--- converter/ppm/ppmtopj.c.orig	2014-04-01 11:09:01.674384526 +0200
+++ converter/ppm/ppmtopj.c	2014-04-01 11:11:56.250523980 +0200
@@ -179,6 +179,7 @@
 	pixels = ppm_readppm( ifp, &cols, &rows, &maxval );
 
 	pm_close( ifp );
+	overflow2(cols,2);
 	obuf = (unsigned char *) pm_allocrow(cols, sizeof(unsigned char));
 	cbuf = (unsigned char *) pm_allocrow(cols * 2, sizeof(unsigned char));
 
Index: converter/ppm/ppmtopjxl.c
===================================================================
--- converter/ppm/ppmtopjxl.c.orig	2014-04-01 11:09:01.849386671 +0200
+++ converter/ppm/ppmtopjxl.c	2014-04-01 11:11:56.250523980 +0200
@@ -305,6 +305,8 @@
         pm_error("image too large; reduce with ppmscale");
     if (maxval > PCL_MAXVAL)
         pm_error("color range too large; reduce with ppmcscale");
+    if (cols < 0 || rows < 0)
+        pm_error("negative size is not possible");
 
     /* Figure out the colormap. */
     pm_message("Computing colormap...");
@@ -325,6 +327,8 @@
         case 0: /* direct mode (no palette) */
             bpp = bitsperpixel(maxval); /* bits per pixel */
             bpg = bpp; bpb = bpp;
+	    overflow2(bpp, 3);
+	    overflow_add(bpp*3, 7);
             bpp = (bpp*3+7)>>3;     /* bytes per pixel now */
             bpr = (bpp<<3)-bpg-bpb; 
             bpp *= cols;            /* bytes per row now */
@@ -334,9 +338,13 @@
         case 3: case 7: pclindex++;
         default:
             bpp = 8/pclindex;
+	    overflow_add(cols, bpp);
+	    if(bpp == 0)
+		pm_error("assert: no bpp");
             bpp = (cols+bpp-1)/bpp;      /* bytes per row */
         }
     }
+    overflow2(bpp,2);
     inrow = (char *)malloc((unsigned)bpp);
     outrow = (char *)malloc((unsigned)bpp*2);
     runcnt = (signed char *)malloc((unsigned)bpp);
Index: converter/ppm/ppmtowinicon.c
===================================================================
--- converter/ppm/ppmtowinicon.c.orig	2014-04-01 11:09:01.844386610 +0200
+++ converter/ppm/ppmtowinicon.c	2014-04-01 11:11:56.251523992 +0200
@@ -12,6 +12,7 @@
 
 #include <math.h>
 #include <string.h>
+#include <stdlib.h>
 
 #include "pm_c_util.h"
 #include "winico.h"
@@ -214,6 +215,7 @@
    MALLOCARRAY_NOFAIL(rowData, rows);
    icBitmap->xBytes = xBytes;
    icBitmap->data   = rowData;
+   overflow2(xBytes, rows);
    icBitmap->size   = xBytes * rows;
    for (y=0;y<rows;y++) {
       u1 * row;
@@ -342,6 +344,7 @@
    MALLOCARRAY_NOFAIL(rowData, rows);
    icBitmap->xBytes = xBytes;
    icBitmap->data   = rowData;
+   overflow2(xBytes, rows);
    icBitmap->size   = xBytes * rows;
 
    for (y=0;y<rows;y++) {
@@ -402,6 +405,7 @@
    MALLOCARRAY_NOFAIL(rowData, rows);
    icBitmap->xBytes = xBytes;
    icBitmap->data   = rowData;
+   overflow2(xBytes, rows);
    icBitmap->size   = xBytes * rows;
 
    for (y=0;y<rows;y++) {
@@ -709,6 +713,10 @@
     entry->bitcount      = bpp;
     entry->ih            = createInfoHeader(entry, xorBitmap, andBitmap);
     entry->colors        = palette->colors;
+    overflow2(4, entry->color_count);
+    overflow_add(xorBitmap->size, andBitmap->size);
+    overflow_add(xorBitmap->size + andBitmap->size, 40);
+    overflow_add(xorBitmap->size + andBitmap->size + 40, 4 * entry->color_count);
     entry->size_in_bytes = 
         xorBitmap->size + andBitmap->size + 40 + (4 * entry->color_count);
     if (verbose) 
Index: converter/ppm/ppmtoxpm.c
===================================================================
--- converter/ppm/ppmtoxpm.c.orig	2014-04-01 11:09:01.843386598 +0200
+++ converter/ppm/ppmtoxpm.c	2014-04-01 11:11:56.251523992 +0200
@@ -197,6 +197,7 @@
     unsigned int i;
 
     /* Allocate memory for printed number.  Abort if error. */
+    overflow_add(digits, 1);
     if (!(str = (char *) malloc(digits + 1)))
         pm_error("out of memory");
 
@@ -314,6 +315,7 @@
     unsigned int charsPerPixel;
     unsigned int xpmMaxval;
     
+    if (includeTransparent) overflow_add(ncolors, 1);
     MALLOCARRAY(cmap, cmapSize);
     if (cmapP == NULL)
         pm_error("Out of memory allocating %u bytes for a color map.",
Index: converter/ppm/qrttoppm.c
===================================================================
--- converter/ppm/qrttoppm.c.orig	2014-04-01 11:09:01.002376287 +0200
+++ converter/ppm/qrttoppm.c	2014-04-01 11:11:56.251523992 +0200
@@ -46,7 +46,7 @@
 
     ppm_writeppminit( stdout, cols, rows, maxval, 0 );
     pixelrow = ppm_allocrow( cols );
-    buf = (unsigned char *) malloc( 3 * cols );
+    buf = (unsigned char *) malloc2( 3 , cols );
     if ( buf == (unsigned char *) 0 )
 	pm_error( "out of memory" );
 
Index: converter/ppm/sldtoppm.c
===================================================================
--- converter/ppm/sldtoppm.c.orig	2014-04-01 11:09:01.841386573 +0200
+++ converter/ppm/sldtoppm.c	2014-04-01 11:11:56.251523992 +0200
@@ -464,6 +464,8 @@
     
     /* Allocate image buffer and clear it to black. */
     
+    overflow_add(ixdots,1);
+    overflow_add(iydots,1);
     pixels = ppm_allocarray(pixcols = ixdots + 1, pixrows = iydots + 1);
     PPM_ASSIGN(rgbcolor, 0, 0, 0);
     ppmd_filledrectangle(pixels, pixcols, pixrows, pixmaxval, 0, 0,
Index: converter/ppm/ximtoppm.c
===================================================================
--- converter/ppm/ximtoppm.c.orig	2014-04-01 11:09:01.842386586 +0200
+++ converter/ppm/ximtoppm.c	2014-04-01 11:11:56.251523992 +0200
@@ -117,6 +117,7 @@
     header->bits_channel = atoi(a_head.bits_per_channel);
     header->alpha_flag = atoi(a_head.alpha_channel);
     if (strlen(a_head.author)) {
+    	overflow_add(strlen(a_head.author),1);
         if (!(header->author = calloc((unsigned int)strlen(a_head.author)+1,
                 1))) {
             pm_message("ReadXimHeader: can't calloc author string" );
@@ -126,6 +127,7 @@
         strncpy(header->author, a_head.author, strlen(a_head.author));
     }
     if (strlen(a_head.date)) {
+        overflow_add(strlen(a_head.date),1);
         if (!(header->date =calloc((unsigned int)strlen(a_head.date)+1,1))){
             pm_message("ReadXimHeader: can't calloc date string" );
             return(0);
@@ -134,6 +136,7 @@
         strncpy(header->date, a_head.date, strlen(a_head.date));
     }
     if (strlen(a_head.program)) {
+        overflow_add(strlen(a_head.program),1);
         if (!(header->program = calloc(
                     (unsigned int)strlen(a_head.program) + 1, 1))) {
             pm_message("ReadXimHeader: can't calloc program string" );
@@ -160,6 +163,7 @@
     if (header->nchannels == 3 && header->bits_channel == 8)
         header->ncolors = 0;
     else if (header->nchannels == 1 && header->bits_channel == 8) {
+	overflow2(header->ncolors, sizeof(Color));
         header->colors = (Color *)calloc((unsigned int)header->ncolors,
                 sizeof(Color));
         if (header->colors == NULL) {
Index: editor/pamcut.c
===================================================================
--- editor/pamcut.c.orig	2014-04-01 11:08:58.060340218 +0200
+++ editor/pamcut.c	2014-04-01 11:11:56.252524004 +0200
@@ -655,6 +655,8 @@
 
     outpam = inpam;    /* Initial value -- most fields should be same */
     outpam.file   = ofP;
+    overflow_add(rightcol, 1);
+    overflow_add(bottomrow, 1);
     outpam.width  = rightcol - leftcol + 1;
     outpam.height = bottomrow - toprow + 1;
 
Index: editor/pbmreduce.c
===================================================================
--- editor/pbmreduce.c.orig	2014-04-01 11:08:58.063340254 +0200
+++ editor/pbmreduce.c	2014-04-01 11:11:56.252524004 +0200
@@ -94,6 +94,7 @@
     if (halftone == QT_FS) {
         unsigned int col;
         /* Initialize Floyd-Steinberg. */
+        overflow_add(newcols, 2);
         MALLOCARRAY(thiserr, newcols + 2);
         MALLOCARRAY(nexterr, newcols + 2);
         if (thiserr == NULL || nexterr == NULL)
Index: editor/pnmgamma.c
===================================================================
--- editor/pnmgamma.c.orig	2014-04-01 11:08:58.276342866 +0200
+++ editor/pnmgamma.c	2014-04-01 11:11:56.252524004 +0200
@@ -586,6 +586,7 @@
                   xelval **             const btableP) {
 
     /* Allocate space for the tables. */
+    overflow_add(maxval, 1);
     MALLOCARRAY(*rtableP, maxval+1);
     MALLOCARRAY(*gtableP, maxval+1);
     MALLOCARRAY(*btableP, maxval+1);
Index: editor/pnmhisteq.c
===================================================================
--- editor/pnmhisteq.c.orig	2014-04-01 11:08:58.064340267 +0200
+++ editor/pnmhisteq.c	2014-04-01 11:11:56.252524004 +0200
@@ -103,6 +103,7 @@
     unsigned int pixelCount;
     unsigned int * lumahist;
 
+    overflow_add(maxval, 1);
     MALLOCARRAY(lumahist, maxval + 1);
     if (lumahist == NULL)
         pm_error("Out of storage allocating array for %u histogram elements",
Index: editor/pnmindex.csh
===================================================================
--- editor/pnmindex.csh.orig	2014-04-01 11:11:56.228523711 +0200
+++ editor/pnmindex.csh	2014-04-01 11:11:56.252524004 +0200
@@ -1,5 +1,8 @@
 #!/bin/csh -f
 #
+echo "Unsafe code, needs debugging, do not ship"
+exit 1
+#
 # pnmindex - build a visual index of a bunch of anymaps
 #
 # Copyright (C) 1991 by Jef Poskanzer.
Index: editor/pnmpad.c
===================================================================
--- editor/pnmpad.c.orig	2014-04-01 11:08:58.214342106 +0200
+++ editor/pnmpad.c	2014-04-01 11:11:56.253524017 +0200
@@ -527,6 +527,8 @@
 
     computePadSizes(cmdline, cols, rows, &lpad, &rpad, &tpad, &bpad);
 
+    overflow_add(cols, lpad);
+    overflow_add(cols + lpad, rpad);
     newcols = cols + lpad + rpad;
 
     if (PNM_FORMAT_TYPE(format) == PBM_TYPE)
Index: editor/pnmremap.c
===================================================================
--- editor/pnmremap.c.orig	2014-04-01 11:08:58.059340205 +0200
+++ editor/pnmremap.c	2014-04-01 11:11:56.253524017 +0200
@@ -427,7 +427,7 @@
     unsigned int plane;
 
     unsigned int const fserrSize = pamP->width + 2;
-
+    overflow_add(pamP->width, 2);
     fserrP->width = pamP->width;
 
     MALLOCARRAY(fserrP->thiserr, pamP->depth);
@@ -465,6 +465,7 @@
 
     int col;
     
+    overflow_add(pamP->width, 2);
     for (col = 0; col < pamP->width + 2; ++col) {
         unsigned int plane;
         for (plane = 0; plane < pamP->depth; ++plane) 
Index: editor/pnmscalefixed.c
===================================================================
--- editor/pnmscalefixed.c.orig	2014-04-01 11:08:58.216342130 +0200
+++ editor/pnmscalefixed.c	2014-04-01 11:11:56.253524017 +0200
@@ -214,6 +214,8 @@
                           const int rows, const int cols,
                           int * newrowsP, int * newcolsP) {
 
+    overflow2(rows, cols);
+
     if (cmdline.pixels) {
         if (rows * cols <= cmdline.pixels) {
             *newrowsP = rows;
@@ -265,6 +267,8 @@
 
     if (*newcolsP < 1) *newcolsP = 1;
     if (*newrowsP < 1) *newrowsP = 1;
+    
+    overflow2(*newcolsP, *newrowsP);
 }        
 
 
@@ -446,6 +450,9 @@
        unfilled.  We can address that by stretching, whereas the other
        case would require throwing away some of the input.
     */
+    
+    overflow2(newcols, SCALE);
+    overflow2(newrows, SCALE);
     sxscale = SCALE * newcols / cols;
     syscale = SCALE * newrows / rows;
 
Index: editor/pnmshear.c
===================================================================
--- editor/pnmshear.c.orig	2014-04-01 11:08:58.065340279 +0200
+++ editor/pnmshear.c	2014-04-01 11:11:56.253524017 +0200
@@ -15,6 +15,7 @@
 #include <assert.h>
 #include <math.h>
 #include <string.h>
+#include <limits.h>
 
 #include "pm_c_util.h"
 #include "mallocvar.h"
@@ -242,6 +243,11 @@
 
     shearfac = fabs(tan(cmdline.angle));
 
+    if(rows * shearfac >= INT_MAX-1)
+      pm_error("image too large");
+    
+    overflow_add(rows * shearfac, cols+1);
+
     newcols = rows * shearfac + cols + 0.999999;
 
     pnm_writepnminit(stdout, newcols, rows, newmaxval, newformat, 0);
Index: editor/ppmdither.c
===================================================================
--- editor/ppmdither.c.orig	2014-04-01 11:08:58.067340304 +0200
+++ editor/ppmdither.c	2014-04-01 11:11:56.254524029 +0200
@@ -355,7 +355,11 @@
         unsigned int const dithMatSize = 
             (dithDim * sizeof(*dithMat)) + /* pointers */
             (dithDim * dithDim * sizeof(**dithMat)); /* data */
-        
+
+        overflow2(dithDim, sizeof(*dithMat));
+        overflow3(dithDim, dithDim, sizeof(**dithMat));
+        overflow_add(dithDim * sizeof(*dithMat), dithDim * dithDim * sizeof(**dithMat));
+
         dithMat = malloc(dithMatSize);
         
         if (dithMat == NULL) 
Index: editor/specialty/pamoil.c
===================================================================
--- editor/specialty/pamoil.c.orig	2014-04-01 11:08:58.070340340 +0200
+++ editor/specialty/pamoil.c	2014-04-01 11:11:56.254524029 +0200
@@ -112,6 +112,7 @@
     tuples = pnm_readpam(ifp, &inpam, PAM_STRUCT_SIZE(tuple_type));
     pm_close(ifp);
 
+    overflow_add(inpam.maxval, 1);
     MALLOCARRAY(hist, inpam.maxval + 1);
     if (hist == NULL)
         pm_error("Unable to allocate memory for histogram.");
Index: generator/pbmtext.c
===================================================================
--- generator/pbmtext.c.orig	2014-04-01 11:08:58.535346041 +0200
+++ generator/pbmtext.c	2014-04-01 11:11:56.254524029 +0200
@@ -96,12 +96,14 @@
         
         for (i = 1; i < argc; ++i) {
             if (i > 1) {
+                overflow_add(totaltextsize, 1);
                 totaltextsize += 1;
                 text = realloc(text, totaltextsize);
                 if (text == NULL)
                     pm_error("out of memory allocating space for input text");
                 strcat(text, " ");
             } 
+            overflow_add(totaltextsize, strlen(argv[i]));
             totaltextsize += strlen(argv[i]);
             text = realloc(text, totaltextsize);
             if (text == NULL)
@@ -712,6 +714,7 @@
                 pm_error("A line of input text is longer than %u characters."
                          "Cannot process.", (unsigned)sizeof(buf)-1);
             if (lineCount >= maxlines) {
+		overflow2(maxlines, 2);
                 maxlines *= 2;
                 REALLOCARRAY(text_array, maxlines);
                 if (text_array == NULL)
@@ -832,6 +835,7 @@
             hmargin = fontP->maxwidth;
         } else {
             vmargin = fontP->maxheight;
+	    overflow2(2, fontP->maxwidth);
             hmargin = 2 * fontP->maxwidth;
         }
     }
Index: generator/pgmcrater.c
===================================================================
--- generator/pgmcrater.c.orig	2014-04-01 11:08:58.536346054 +0200
+++ generator/pgmcrater.c	2014-04-01 11:11:56.254524029 +0200
@@ -250,7 +250,7 @@
     /* Acquire the elevation array and initialize it to mean
        surface elevation. */
 
-    MALLOCARRAY(aux, SCRX * SCRY);
+    aux = (unsigned short *) malloc3(SCRX, SCRY, sizeof(short));
     if (aux == NULL) 
         pm_error("out of memory allocating elevation array");
 
Index: generator/pgmkernel.c
===================================================================
--- generator/pgmkernel.c.orig	2014-04-01 11:11:56.255524041 +0200
+++ generator/pgmkernel.c	2014-04-01 11:15:52.877427867 +0200
@@ -214,6 +214,7 @@
 
     /* Output matrix is symmetric vertically and horizontally. */
 
+    overflow_add(cmdline.rows, 1);
     arows = (cmdline.rows + 1) / 2;
         /* Half the number of rows.  Add 1 if odd. */
     halfKernel = pgm_allocarray(cmdline.cols, arows);
Index: lib/libpam.c
===================================================================
--- lib/libpam.c.orig	2014-04-01 11:08:59.184353998 +0200
+++ lib/libpam.c	2014-04-01 11:11:56.255524041 +0200
@@ -223,7 +223,8 @@
     unsigned int const bytesPerTuple = allocationDepth(pamP) * sizeof(sample);
     tuple * tuplerow;
 
-    tuplerow = malloc(pamP->width * (sizeof(tuple *) + bytesPerTuple));
+    overflow_add(sizeof(tuple *), bytesPerTuple);
+    tuplerow = malloc2(pamP->width, (sizeof(tuple *) + bytesPerTuple));
                       
     if (tuplerow != NULL) {
         /* Now we initialize the pointers to the individual tuples
Index: lib/libpammap.c
===================================================================
--- lib/libpammap.c.orig	2014-04-01 11:08:59.183353986 +0200
+++ lib/libpammap.c	2014-04-01 11:11:56.255524041 +0200
@@ -107,6 +107,8 @@
     */
     struct tupleint_list_item * retval;
 
+    overflow2(pamP->depth, sizeof(sample));
+    overflow_add(sizeof(*retval)-sizeof(retval->tupleint.tuple), pamP->depth*sizeof(sample));
     unsigned int const size = 
         sizeof(*retval) - sizeof(retval->tupleint.tuple) 
         + pamP->depth * sizeof(sample);
Index: lib/libpbm1.c
===================================================================
--- lib/libpbm1.c.orig	2014-04-01 11:08:59.190354072 +0200
+++ lib/libpbm1.c	2014-04-01 11:11:56.256524054 +0200
@@ -78,6 +78,7 @@
     } else {        
         pm_filepos const bytesPerRow    = (cols+7)/8;
         pm_filepos const needRasterSize = rows * bytesPerRow;
+        overflow2(bytesPerRow, rows);
         pm_check(fileP, checkType, needRasterSize, retvalP);
     }
 }
Index: lib/libpm.c
===================================================================
--- lib/libpm.c.orig	2014-04-01 11:11:56.219523600 +0200
+++ lib/libpm.c	2014-04-01 11:11:56.256524054 +0200
@@ -807,4 +807,53 @@
 }
 
 
+/*
+ *	Maths wrapping
+ */
+ 
+void __overflow2(int a, int b)
+{
+	if(a < 0 || b < 0)
+		pm_error("object too large");
+	if(b == 0)
+		return;
+	if(a > INT_MAX / b)
+		pm_error("object too large");
+}
+
+void overflow3(int a, int b, int c)
+{
+	overflow2(a,b);
+	overflow2(a*b, c);
+}
+
+void overflow_add(int a, int b)
+{
+	if( a > INT_MAX - b)
+		pm_error("object too large");
+}
+
+void *malloc2(int a, int b)
+{
+	overflow2(a, b);
+	if(a*b == 0)
+		pm_error("Zero byte allocation");
+	return malloc(a*b);
+}
+
+void *malloc3(int a, int b, int c)
+{
+	overflow3(a, b, c);
+	if(a*b*c == 0)
+		pm_error("Zero byte allocation");
+	return malloc(a*b*c);
+}
+
+void *realloc2(void * a, int b, int c)
+{
+	overflow2(b, c);
+	if(b*c == 0)
+		pm_error("Zero byte allocation");
+	return realloc(a, b*c);
+}
 
Index: lib/pm.h
===================================================================
--- lib/pm.h.orig	2014-04-01 11:08:59.188354047 +0200
+++ lib/pm.h	2014-04-01 11:11:56.256524054 +0200
@@ -432,4 +432,11 @@
 #endif
 
 
+void *malloc2(int, int);
+void *malloc3(int, int, int);
+#define overflow2(a,b) __overflow2(a,b)
+void __overflow2(int, int);
+void overflow3(int, int, int);
+void overflow_add(int, int);
+
 #endif
Index: other/pnmcolormap.c
===================================================================
--- other/pnmcolormap.c.orig	2014-04-01 11:08:57.470332985 +0200
+++ other/pnmcolormap.c	2014-04-01 11:11:56.256524054 +0200
@@ -840,6 +840,7 @@
             pamP->width = intsqrt;
         else 
             pamP->width = intsqrt + 1;
+            overflow_add(intsqrt, 1);
     }
     {
         unsigned int const intQuotient = colormap.size / pamP->width;
Index: urt/README
===================================================================
--- urt/README.orig	2014-04-01 11:09:02.144390288 +0200
+++ urt/README	2014-04-01 11:11:56.256524054 +0200
@@ -18,3 +18,8 @@
 defines stdout as a variable, so that wouldn't compile.  So I changed
 it to NULL and added a line to rle_hdr_init to set that field to
 'stdout' dynamically.  2000.06.02 BJH.
+
+Redid the code to check for maths overflows and other crawly horrors.
+Removed pipe through and compress support (unsafe)
+
+Alan Cox <alan@redhat.com>
Index: urt/rle_addhist.c
===================================================================
--- urt/rle_addhist.c.orig	2014-04-01 11:09:02.146390312 +0200
+++ urt/rle_addhist.c	2014-04-01 11:11:56.257524066 +0200
@@ -14,6 +14,8 @@
  * If you modify this software, you should include a notice giving the
  * name of the person performing the modification, the date of modification,
  * and the reason for such modification.
+ *
+ *  2002-12-19: Fix maths wrapping bugs. Alan Cox <alan@redhat.com>
  */
 /* 
  * rle_addhist.c - Add to the HISTORY comment in header
@@ -70,13 +72,19 @@
         return;
     
     length = 0;
-    for (i = 0; argv[i]; ++i)
+    for (i = 0; argv[i]; ++i) {
+	overflow_add(length, strlen(argv[i]));
+	overflow_add(length+1, strlen(argv[i]));
         length += strlen(argv[i]) +1;   /* length of each arg plus space. */
+    }
 
     time(&temp);
     timedate = ctime(&temp);
     length += strlen(timedate);        /* length of date and time in ASCII. */
 
+    overflow_add(strlen(padding), 4);
+    overflow_add(strlen(histoire), strlen(padding) + 4);
+    overflow_add(length, strlen(histoire) + strlen(padding) + 4);
     length += strlen(padding) + 3 + strlen(histoire) + 1;
         /* length of padding, "on "  and length of history name plus "="*/
     if (in_hdr) /* if we are interested in the old comments... */
@@ -84,9 +92,12 @@
     else
         old = NULL;
     
-    if (old && *old)
+    if (old && *old) {
+	overflow_add(length, strlen(old));
         length += strlen(old);       /* add length if there. */
+    }
 
+    overflow_add(length, 1);
     ++length;                               /*Cater for the null. */
 
     MALLOCARRAY(newc, length);
Index: urt/rle_getrow.c
===================================================================
--- urt/rle_getrow.c.orig	2014-04-01 11:09:02.144390288 +0200
+++ urt/rle_getrow.c	2014-04-01 11:11:56.257524066 +0200
@@ -17,6 +17,8 @@
  *
  *  Modified at BRL 16-May-88 by Mike Muuss to avoid Alliant STDC desire
  *  to have all "void" functions so declared.
+ *
+ *  2002-12-19: Fix maths wrapping bugs. Alan Cox <alan@redhat.com>
  */
 /* 
  * rle_getrow.c - Read an RLE file in.
@@ -168,6 +170,7 @@
         register char * cp;
 
         VAXSHORT( comlen, infile ); /* get comment length */
+	overflow_add(comlen, 1);
         evenlen = (comlen + 1) & ~1;    /* make it even */
         if ( evenlen )
         {
Index: urt/rle_hdr.c
===================================================================
--- urt/rle_hdr.c.orig	2014-04-01 11:09:02.145390300 +0200
+++ urt/rle_hdr.c	2014-04-01 11:11:56.257524066 +0200
@@ -14,6 +14,8 @@
  * If you modify this software, you should include a notice giving the
  * name of the person performing the modification, the date of modification,
  * and the reason for such modification.
+ *
+ *  2002-12-19: Fix maths wrapping bugs. Alan Cox <alan@redhat.com>
  */
 /* 
  * rle_hdr.c - Functions to manipulate rle_hdr structures.
@@ -80,7 +82,10 @@
     /* Fill in with copies of the strings. */
     if ( the_hdr->cmd != pgmname )
     {
-	char *tmp = (char *)malloc( strlen( pgmname ) + 1 );
+	char *tmp ;
+
+	overflow_add(strlen(pgmname), 1);
+	tmp = malloc( strlen( pgmname ) + 1 );
 	RLE_CHECK_ALLOC( pgmname, tmp, 0 );
 	strcpy( tmp, pgmname );
 	the_hdr->cmd = tmp;
@@ -88,7 +93,9 @@
 
     if ( the_hdr->file_name != fname )
     {
-	char *tmp = (char *)malloc( strlen( fname ) + 1 );
+	char *tmp;
+	overflow_add(strlen(fname), 1);
+	tmp = malloc( strlen( fname ) + 1 );
 	RLE_CHECK_ALLOC( pgmname, tmp, 0 );
 	strcpy( tmp, fname );
 	the_hdr->file_name = tmp;
@@ -153,6 +160,7 @@
     if ( to_hdr->bg_color )
     {
 	int size = to_hdr->ncolors * sizeof(int);
+	overflow2(to_hdr->ncolors, sizeof(int));
 	to_hdr->bg_color = (int *)malloc( size );
 	RLE_CHECK_ALLOC( to_hdr->cmd, to_hdr->bg_color, "background color" );
 	memcpy( to_hdr->bg_color, from_hdr->bg_color, size );
@@ -161,7 +169,7 @@
     if ( to_hdr->cmap )
     {
 	int size = to_hdr->ncmap * (1 << to_hdr->cmaplen) * sizeof(rle_map);
-	to_hdr->cmap = (rle_map *)malloc( size );
+	to_hdr->cmap = (rle_map *)malloc3( to_hdr->ncmap, 1<<to_hdr->cmaplen, sizeof(rle_map));
 	RLE_CHECK_ALLOC( to_hdr->cmd, to_hdr->cmap, "color map" );
 	memcpy( to_hdr->cmap, from_hdr->cmap, size );
     }
@@ -174,11 +182,16 @@
 	int size = 0;
 	CONST_DECL char **cp;
 	for ( cp=to_hdr->comments; *cp; cp++ )
+	{
+	    overflow_add(size, 1);
 	    size++;		/* Count the comments. */
+ 	}
 	/* Check if there are really any comments. */
 	if ( size )
 	{
+	    overflow_add(size, 1);
 	    size++;		/* Copy the NULL pointer, too. */
+	    overflow2(size, sizeof(char *));
 	    size *= sizeof(char *);
 	    to_hdr->comments = (CONST_DECL char **)malloc( size );
 	    RLE_CHECK_ALLOC( to_hdr->cmd, to_hdr->comments, "comments" );
Index: urt/rle.h
===================================================================
--- urt/rle.h.orig	2014-04-01 11:09:02.146390312 +0200
+++ urt/rle.h	2014-04-01 11:11:56.257524066 +0200
@@ -14,6 +14,9 @@
  * If you modify this software, you should include a notice giving the
  * name of the person performing the modification, the date of modification,
  * and the reason for such modification.
+ *
+ *  2002-12-19: Fix maths wrapping bugs. Alan Cox <alan@redhat.com>
+ *  Header declarations needed
  */
 /* 
  * rle.h - Global declarations for Utah Raster Toolkit RLE programs.
@@ -160,6 +163,17 @@
  */
 extern rle_hdr rle_dflt_hdr;
 
+/* 
+ * Provided by pm library
+ */
+ 
+extern void overflow_add(int, int);
+#define overflow2(a,b) __overflow2(a,b)
+extern void __overflow2(int, int);
+extern void overflow3(int, int, int);
+extern void *malloc2(int, int);
+extern void *malloc3(int, int, int);
+extern void *realloc2(void *, int, int);
 
 /* Declare RLE library routines. */
 
Index: urt/rle_open_f.c
===================================================================
--- urt/rle_open_f.c.orig	2014-04-01 11:09:02.143390276 +0200
+++ urt/rle_open_f.c	2014-04-01 11:11:56.258524078 +0200
@@ -163,65 +163,7 @@
                    FILE **       const fpP,
                    bool *        const noSubprocessP,
                    const char ** const errorP) {
-
-#ifdef NO_OPEN_PIPES
     *noSubprocessP = TRUE;
-#else
-    const char *cp;
-
-    reapChildren(catchingChildrenP, pids);
-
-    /*  Real file, not stdin or stdout.  If name ends in ".Z",
-     *  pipe from/to un/compress (depending on r/w mode).
-     *  
-     *  If it starts with "|", popen that command.
-     */
-        
-    cp = file_name + strlen(file_name) - 2;
-    /* Pipe case. */
-    if (file_name[0] == '|') {
-        pid_t thepid;     /* PID from my_popen */
-
-        *noSubprocessP = FALSE;
-
-        *fpP = my_popen(file_name + 1, mode, &thepid);
-        if (*fpP == NULL)
-            *errorP = "%s: can't invoke <<%s>> for %s: ";
-        else {
-            /* One more child to catch, eventually. */
-            if (*catchingChildrenP < MAX_CHILDREN)
-                pids[(*catchingChildrenP)++] = thepid;
-        }
-    } else if (cp > file_name && *cp == '.' && *(cp + 1) == 'Z' ) {
-        /* Compress case. */
-        pid_t thepid;     /* PID from my_popen. */
-        const char * command;
-
-        *noSubprocessP = FALSE;
-        
-        if (*mode == 'w')
-            pm_asprintf(&command, "compress > %s", file_name);
-        else if (*mode == 'a')
-            pm_asprintf(&command, "compress >> %s", file_name);
-        else
-            pm_asprintf(&command, "compress -d < %s", file_name);
-        
-        *fpP = my_popen(command, mode, &thepid);
-
-        if (*fpP == NULL)
-            *errorP = "%s: can't invoke 'compress' program, "
-                "trying to open %s for %s";
-        else {
-            /* One more child to catch, eventually. */
-            if (*catchingChildrenP < MAX_CHILDREN)
-                pids[(*catchingChildrenP)++] = thepid;
-        }
-        pm_strfree(command);
-    } else {
-        *noSubprocessP = TRUE;
-        *errorP = NULL;
-    }
-#endif
 }
 
 
Index: urt/rle_putcom.c
===================================================================
--- urt/rle_putcom.c.orig	2014-04-01 11:09:02.143390276 +0200
+++ urt/rle_putcom.c	2014-04-01 11:11:56.258524078 +0200
@@ -14,6 +14,8 @@
  * If you modify this software, you should include a notice giving the
  * name of the person performing the modification, the date of modification,
  * and the reason for such modification.
+ *
+ *  2002-12-19: Fix maths wrapping bugs. Alan Cox <alan@redhat.com>
  */
 /* 
  * rle_putcom.c - Add a picture comment to the header struct.
@@ -98,12 +100,14 @@
         const char * v;
         const char ** old_comments;
         int i;
-        for (i = 2, cp = the_hdr->comments; *cp != NULL; ++i, ++cp)
+        for (i = 2, cp = the_hdr->comments; *cp != NULL; ++i, ++cp) {
+	    overflow_add(i, 1);
             if (match(value, *cp) != NULL) {
                 v = *cp;
                 *cp = value;
                 return v;
             }
+	}
         /* Not found */
         /* Can't realloc because somebody else might be pointing to this
          * comments block.  Of course, if this were true, then the
Index: urt/Runput.c
===================================================================
--- urt/Runput.c.orig	2014-04-01 11:09:02.147390325 +0200
+++ urt/Runput.c	2014-04-01 11:11:56.258524078 +0200
@@ -17,6 +17,8 @@
  *
  *  Modified at BRL 16-May-88 by Mike Muuss to avoid Alliant STDC desire
  *  to have all "void" functions so declared.
+ *
+ *  2002-12-19: Fix maths wrapping bugs. Alan Cox <alan@redhat.com>
  */
 /* 
  * Runput.c - General purpose Run Length Encoding.
@@ -202,9 +204,11 @@
     if ( the_hdr->background != 0 )
     {
 	register int i;
-	register rle_pixel *background =
-	    (rle_pixel *)malloc( (unsigned)(the_hdr->ncolors + 1) );
+	register rle_pixel *background;
 	register int *bg_color;
+
+	overflow_add(the_hdr->ncolors,1);
+	background = (rle_pixel *)malloc( (unsigned)(the_hdr->ncolors + 1) );
 	/* 
 	 * If even number of bg color bytes, put out one more to get to 
 	 * 16 bit boundary.
@@ -224,7 +228,7 @@
 	/* Big-endian machines are harder */
 	register int i, nmap = (1 << the_hdr->cmaplen) *
 			       the_hdr->ncmap;
-	register char *h_cmap = (char *)malloc( nmap * 2 );
+	register char *h_cmap = (char *)malloc2( nmap, 2 );
 	if ( h_cmap == NULL )
 	{
 	    fprintf( stderr,
Index: urt/scanargs.c
===================================================================
--- urt/scanargs.c.orig	2014-04-01 11:09:02.142390263 +0200
+++ urt/scanargs.c	2014-04-01 11:11:56.258524078 +0200
@@ -38,6 +38,8 @@
  *
  *  Modified at BRL 16-May-88 by Mike Muuss to avoid Alliant STDC desire
  *  to have all "void" functions so declared.
+ *
+ *  2002-12-19: Fix maths wrapping bugs. Alan Cox <alan@redhat.com>
  */
 
 #include <stdio.h>
@@ -62,8 +64,8 @@
 /* 
  * Storage allocation macros
  */
-#define NEW( type, cnt )	(type *) malloc( (cnt) * sizeof( type ) )
-#define RENEW( type, ptr, cnt )	(type *) realloc( ptr, (cnt) * sizeof( type ) )
+#define NEW( type, cnt )	(type *) malloc2( (cnt) , sizeof( type ) )
+#define RENEW( type, ptr, cnt )	(type *) realloc2( ptr, (cnt), sizeof( type ) )
 
 static CONST_DECL char * prformat( CONST_DECL char *, int );
 static int isnum( CONST_DECL char *, int, int );
